/*
 *	main.c
 *
 *	
 *
 *	* Thu Nov 14 22:45:00 JST 2002 Naoyuki Sawa
 *	- 1st [XB
 *	* Thu Nov 14 23:52:00 JST 2002 Naoyuki Sawa
 *	- tbVƃXg[g̐J[ht̂CB
 */
#include "app.h"

//#define USE_MUSIC /* yCugꍇ́ÃV{`Ă */
#ifdef USE_MUSIC
#include "instdef.c"
#define music_play(data) do { music_stop(); PlayMusic((unsigned char*)(data)); } while(0)
#define music_stop() do { StopMusic(); sound_stop(music_wch); } while(0)
#else /*USE_MUSIC*/
#define music_play(data) ((void)0)
#define music_stop() ((void)0)
#endif /*USE_MUSIC*/

#define V_SCREEN /* cʃ[hgꍇ́ÃV{`Ă */
#ifdef V_SCREEN
#undef DISP_X
#undef DISP_Y
#define DISP_X	 88
#define DISP_Y	128
#endif /*V_SCREEN*/

extern const unsigned char S1[];
extern const unsigned char S2[];
extern const unsigned char S3[];
extern const unsigned char S4[];

/****************************************************************************
 *	萔E^
 ****************************************************************************/

#define FPS		20			/* t[[g */
#define SEC(s)		((int)(FPS * (s)))	/* b->t[ϊ */

typedef struct _CARD {
	unsigned char suit;	/* 0:Xy[h/1:_C/2:Nu/3:n[g/4:W[J[ */
	unsigned char number;	/* 0:G[X`12:LO (W[J[0ݒ)        */
} CARD;
static const CARD reversed = { 4,  1 };	/*  */
//static const CARD flash_w  = { 4, 10 };	/* tbVO() */
static const CARD flash_b  = { 4, 11 };	/* tbVO() */
static const CARD guide    = { 4, 12 };	/* g */

				/* (0:) */
#define CAST_HC		1	/* nCJ[h */
#define CAST_1P		2	/* yA */
#define CAST_2P		3	/* c[yA */
#define CAST_3C		4	/* X[J[h */
#define CAST_FL		5	/* tbV */
#define CAST_ST		6	/* Xg[g */
#define CAST_FH		7	/* tnEX */
#define CAST_4C		8	/* tH[J[h */
#define CAST_SF		9	/* Xg[gtbV */
#define CAST_RSF	10	/* CXg[gtbV */
#define CAST_5C		11	/* t@CuJ[h */
#define NUM_CAST	12
const int cast_pts[NUM_CAST] = {
	-1,	/* () */
	0,	/* nCJ[h */
	200,	/* yA */
	400,	/* c[yA */
	800,	/* X[J[h */
	1000,	/* tbV */
	1400,	/* Xg[g */
	1800,	/* tnEX */
	2000,	/* tH[J[h */
	2400,	/* Xg[gtbV */
	2800,	/* CXg[gtbV */
	3000,	/* t@CuJ[h */
};
const char* const cast_str[NUM_CAST] = {
	NULL,	/* () */
	"HC ",	/* nCJ[h */
	"1P ",	/* yA */
	"2P ",	/* c[yA */
	"3C ",	/* X[J[h */
	"FL ",	/* tbV */
	"ST ",	/* Xg[g */
	"FH ",	/* tnEX */
	"4C ",	/* tH[J[h */
	"SF ",	/* Xg[gtbV */
	"RSF",	/* CXg[gtbV */
	"5C ",	/* t@CuJ[h */
};
const char* const cast_name[NUM_CAST] = {
/*	 OPQRSTUV */
	NULL,
	"nCJ[h",
	"yA",
	"c[yA",
	"X[J[h",
	"tbV",
	"Xg[g",
	"tnEX",
	"tH[J[h",
	"ڰׯ",
	"۲ٽڰׯ",
	"t@CuJ[h",
};
const char* const cast_doc[NUM_CAST] = {
/*	 OPQRSTUV */
	NULL,
	"ȂB",
	"񖇂\ngB",
	"񖇂\ngB",
	"OB",
	"SށB",
	"܂񂾐B",
	"OƁA\n񖇁B",
	"lB",
	"SނŁA\n܂񂾐B",
	"SނŁA\nw10ipj`xB",
	"lƁA\nW[J[B",
};
const CARD cast_smpl[NUM_CAST][5] = {
	{{0,0}},
	{{1, 1},{3, 7},{0,11},{0,12},{3, 6}},
	{{3, 9},{2, 9},{1, 3},{3,10},{3, 7}},
	{{3, 6},{1, 6},{3,11},{2,11},{0, 7}},
	{{0,10},{3,10},{1,10},{0, 0},{1, 1}},
	{{1, 1},{1, 3},{1, 6},{1,10},{1,11}},
	{{1, 3},{2, 4},{2, 5},{3, 6},{0, 7}},
	{{0, 9},{3, 9},{3, 9},{3, 7},{0, 7}},
	{{2,11},{0,11},{1,11},{3,11},{0,12}},
	{{3, 6},{3, 7},{3, 8},{3, 9},{3,10}},
	{{0, 9},{0,10},{0,11},{0,12},{0, 0}},
	{{0, 0},{1, 0},{2, 0},{3, 0},{4, 0}},
};

typedef struct _GI {
	int round;	/* Ehԍ */
	int score;	/* v_ */
	int level;	/* NA_ */
	int stock;	/* z_ */
	int total;	/* ݂̓_ */
	int info_cnt;	/* EhJn̏\JE^ */
	int info_pos;	/* \ʒu(0:\Ȃ) */

	/* RD(l) */
	CARD yama[4][(53 + 3) / 4];	/* 4(X[c)~13(io[){1(W[J[)53 */
	int n_yama[4];			/* ẽJ[h */

	/* D(ܗ) */
	CARD ba[5][5];
	int n_ba[5];	/* ẽJ[h */

	/*  */
	int cast_h[5];	/*  */
	int cast_v[5];	/*  */
	int cast_d[2];	/* ΂ߖ(0:m^n/1:m_n) */

	/* I */
	int phase;	/* PHASE_* */
	int yama_sel;	/* RD̑I */
	int ba_sel;	/* D̑I */

	/* tbVO */
	int flash;	/* 0:ʏ/1:/2: */
	int flash_h;	/* s  (CfNXɑΉ) */
	int flash_v;	/*   (CfNXɑΉ) */
	int flash_d;	/* ΂(CfNXɑΉ) */
} GI;

#define PHASE_PRE	0	/* O */
#define PHASE_YAMA_SEL	1	/* RDI */
#define PHASE_BA_SEL	2	/* DI */
#define PHASE_POST	3	/* ㏈ */

/****************************************************************************
 *	ϐ
 ****************************************************************************/

unsigned char vbuff[DISP_X * DISP_Y];	/* zVRAM */
SURFACE surface;			/* zVRAM̃T[tFCX */
RENDER render;				/* zVRAMւ̕` */

int now;				/* O[o^C} */
int joy;				/* pbh */

extern const unsigned char PAT[];
//extern const unsigned char BG[];
TEXTURE pat;
//TEXTURE bg;

int hiscore;
GI gi;

/****************************************************************************
 *	֐錾
 ****************************************************************************/

void app_init();
void app_exit();
void schedule();
int demo();
void game();

void card_disp(int x, int y, const CARD* card);
void cast_disp(int x, int y, int cast, int rot);
int chk_cast(CARD card[5]);
void field_disp();
void result_disp();
void doc_disp(int cast);

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/* B */
	app_init();

	/* C[vB */
	for(;;) {
		if(demo() != 0) break;
		game();
	}

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* ʓIȏB */
	pceLCDDispStop();
#ifdef V_SCREEN
	pceLCDSetBuffer(_def_vbuff);
#else /*V_SCREEN*/
	pceLCDSetBuffer(vbuff);
#endif /*V_SCREEN*/
	pceAppSetProcPeriod(1000 / FPS);
	pcePadSetTrigMode(PP_MODE_SINGLE);
	pceLCDDispStart();

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
	render_init(&render, &surface, 0, 0, 0, 0, 0, 0, 0);

#ifdef USE_MUSIC
	/* yCu܂B */
	InitMusic();
#endif /*USE_MUSIC*/

	/* N[Abv֐o^B */
	atexit(app_exit);

/*{{AvP[VL̏*/
	srand(pceTimerGetCount());
	/* rbg}bvB */
	texture_init(&pat, PAT);
	//texture_init(&bg, BG);
	render.context->texture = &pat; /* eNX`Œ */
/*}}AvP[VL̏*/
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
#ifdef USE_MUSIC
	/* mɉyt~܂B
	 * TEh̒~̓CupceAppExit()ōsĂ̂ŁA
	 * ł͕Kv܂B
	 */
	StopMusic();
#endif /*USE_MUSIC*/
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
#define PAUSE_FONT	0x80		/* PAUSEtHg         */
#define PAUSE_COLOR	0x130		/* PAUSEJ[(wip) */
//#define PAUSE_COLOR	0x203		/* PAUSEJ[(wip) */
#define PAUSE_STR	"PAUSE"		/* PAUSEbZ[W       */
#define PAUSE_W		(5 * 5 + 2)	/* PAUSEbZ[W̉ */
#define PAUSE_H		(10    + 2)	/* PAUSEbZ[W̏c */
#define PAUSE_X		((DISP_X - PAUSE_W) / 2) /* \ʒu */
#define PAUSE_Y		((DISP_Y - PAUSE_H) / 2) /* \ʒu */

	int pause, x, y;
	/* PAUSEbZ[Ẅ̃C[Wޔpobt@́A324oCgKvłB
	 * X^bNɎ̂͊댯łAstaticɎ̖̂ʂłB
	 * ŁAPAUSEɂ̂݃q[vmۂ邱Ƃɂ܂B
	 */
	//unsigned char save[PAUSE_H][PAUSE_W];
	unsigned char (*save)[PAUSE_W] = NULL/*x}*/;

	pause = 0;
	for(;;) {
#ifdef V_SCREEN
		{ /* vbuff(c)_def_vbuff()ϊ */
			unsigned char *dst, *src;
			dst = &_def_vbuff[0];     /* ]̉ʂ͍ォ瑖Jn܂ */
			src = &vbuff[DISP_X - 1]; /* ]̏cʂ͉Eォ瑖Jn܂ */
			for(x = DISP_X - 1; x >= 0; x--) {
				for(y = 0; y < DISP_Y; y++) {
					*dst = *src;
					dst += 1;      /* ʂEɑ܂ */
					src += DISP_X; /* cʂɑ܂ */
				}
				                            /* ʂ͊Ɏ̍sֈړĂ܂ */
				src -= DISP_X * DISP_Y + 1; /* cʂ̗̈ԏֈړ܂ */
			}
		}
#endif /*V_SCREEN*/
		pceLCDTrans();		/* ʍXV */
		yield();		/* VXe */
		joy = pcePadGet();	/* pbhԍXV */
#ifdef V_SCREEN
		joy = (joy & ~(PAD_LF | PAD_RI | PAD_UP | PAD_DN | /* cʗp͕ϊ */
			       TRG_LF | TRG_RI | TRG_UP | TRG_DN))
			| (joy & PAD_LF ? PAD_UP : 0)
			| (joy & PAD_RI ? PAD_DN : 0)
			| (joy & PAD_UP ? PAD_RI : 0)
			| (joy & PAD_DN ? PAD_LF : 0)
			| (joy & TRG_LF ? TRG_UP : 0)
			| (joy & TRG_RI ? TRG_DN : 0)
			| (joy & TRG_UP ? TRG_RI : 0)
			| (joy & TRG_DN ? TRG_LF : 0);
#endif /*V_SCREEN*/

		/* PAUSEB */
		if(joy & TRG_START) {
			pause = !pause;	/* PAUSEԐ؂ւ */
			if(pause) {	/* PAUSE IN */
				/* PAUSEbZ[W\̃C[WޔB */
				save = (unsigned char (*)[PAUSE_W])malloc(PAUSE_W * PAUSE_H); /* C[Wޔpobt@m */
				if(save == NULL) DIE();
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						save[y][x] = vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)];
					}
				}
			} else {	/* PAUSE OUT */
				/* PAUSEbZ[W\̃C[W𕜋AB */
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
					}
				}
				free(save); /* C[Wޔpobt@J */
			}
		}
		if(!pause) break;

		/* PAUSEbZ[W_ŕ\B */
		if(pceTimerGetCount() % 1000 < 750) {
			render_string_framed(&render, PAUSE_X, PAUSE_Y, PAUSE_STR, PAUSE_FONT, PAUSE_COLOR);
		} else {
			for(y = 0; y < PAUSE_H; y++) {
				for(x = 0; x < PAUSE_W; x++) {
					vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
				}
			}
		}
	}
	now++;	/* O[o^C}XV */

#undef PAUSE_FONT
#undef PAUSE_COLOR
#undef PAUSE_STR
#undef PAUSE_W
#undef PAUSE_H
#undef PAUSE_X
#undef PAUSE_Y
}

/****************************************************************************
 *	demo
 ****************************************************************************/

int
demo()
{
	int result, cast, x, y;
	char str[100];

	cast = 0;
	for(;;) {
		schedule();
		memset(vbuff, 0, sizeof vbuff);
		if(cast) {
			doc_disp(cast);
			if(joy & TRG_LF) {
				cast--;
				sound_play(1, S4);
			} else if(joy & TRG_RI) {
				cast++;
				sound_play(1, S4);
				if(cast == NUM_CAST) cast = 0;
			} else if(joy & (TRG_A | TRG_B | TRG_SELECT)) {
				cast = 0;
				sound_play(1, S4);
			}
		} else {
			/* X^[gHIH */
			if(joy & TRG_SELECT) {
				result = -1;
				break;
			}
			if(joy & TRG_A) {
				result = 0;
				break;
			}

			/* ̐\H */
			if(joy & TRG_RI) {
				cast = 1;
				sound_play(1, S4);
			} else if(joy & TRG_LF) {
				cast = NUM_CAST - 1;
				sound_play(1, S4);
			}

			/* ^Cg\B */
			sprintf(str, "@");
			x = (DISP_X - (5 * strlen(str) + 2)) / 2;
			y = (DISP_Y - (10 + 2)) / 3;
			render_string_framed(&render, x, y, str, 0, 0x321);

			/* XRA\B */
			sprintf(str, "HI");
			x = 0 + 1;
			y = 0 + 1;
			render_string(&render, x, y, str, 2, 3);
			sprintf(str, "%d", hiscore);
			x = 0 + 1;
			y = 8 + 1;
			render_string(&render, x, y, str, 2, 3);
			sprintf(str, "1P");
			x = DISP_X - (strlen(str) * 4);
			y = 0 + 1;
			render_string(&render, x, y, str, 2, 3);
			sprintf(str, "%d", gi.score);
			x = DISP_X - (strlen(str) * 4);
			y = 8 + 1;
			render_string(&render, x, y, str, 2, 3);

			/* vvg\B */
			if(now % SEC(1.0) < SEC(0.67)) {
				sprintf(str, " A START");
				x = (DISP_X - (strlen(str) * 5 + 1)) / 2;
				y = DISP_Y - 6 * 8;
				render_string(&render, x, y, str, 0, 3);
				sprintf(str, "SEL EXIT");
				x = (DISP_X - (strlen(str) * 5 + 1)) / 2;
				y = DISP_Y - 6 * 6;
				render_string(&render, x, y, str, 0, 3);
			}
		}
		/* vvg\#2B */
		if(now % SEC(1.0) < SEC(0.67)) {
			y = DISP_Y - 6;
			x = 1;
			render_string(&render, x, y, "<<", 2, 3);
			x = DISP_X - 4 * 2;
			render_string(&render, x, y, ">>", 2, 3);
		}
	}

	return result;
}

/****************************************************************************
 *	game
 ****************************************************************************/

static void
round_init()
{
	int n, col, pos;
	CARD card[53];

	/* round=0Ȃŏ̏A0ȊOȂ玟̃Eh̏B */
	if(gi.round == 0) {
		gi.round = 1;
		gi.stock = 0;
		gi.level = 3000; /* NA_̏l */
		gi.total = 0;
		gi.score = 0;
	} else {
		gi.round++;
		gi.stock += gi.total - gi.level;
		gi.level += 1000; /* ʖ̃NA_ */
		gi.total = 0;
		/*gi.score͂̂܂*/
	}
	gi.info_cnt = 0;
	gi.info_pos = 0;

	/* RDNAB */
	memset(gi.yama, 0, sizeof gi.yama);
	memset(gi.n_yama, 0, sizeof gi.n_yama);

	/* DNAB */
	memset(gi.ba, 0, sizeof gi.ba);
	memset(gi.n_ba, 0, sizeof gi.n_ba);

	/* NAB */
	memset(gi.cast_h, 0, sizeof gi.cast_h);
	memset(gi.cast_v, 0, sizeof gi.cast_v);
	memset(gi.cast_d, 0, sizeof gi.cast_d);

	/* IB */
	gi.phase = 0;
	gi.yama_sel = 0;
	gi.ba_sel = 0;

	/* tbVOB */
	gi.flash = 0;
	gi.flash_h = 0;
	gi.flash_v = 0;
	gi.flash_d = 0;

	/* Xy[h``W[J[̕т܂B */
	for(n = 0; n < 53; n++) {
		card[n].suit   = n / 13;
		card[n].number = n % 13;
	}

	/* ̒烉_ɎoĎRDցB */
	schedule(); /*{{BR}hpL[}}*/
	col = 0;
	while(n > 0) {
		pos = rand() % n;
		/*{{BR}h*/
		if((joy & (PAD_UP | PAD_DN | PAD_LF | PAD_RI))
		       == (PAD_UP | PAD_DN | PAD_LF | PAD_RI)) pos = n - 1;
		/*}}BR}h*/
		gi.yama[col][gi.n_yama[col]++] = card[pos];
		memmove(&card[pos], &card[pos + 1], sizeof(CARD) * ((n - 1) - pos));
		col = col < 4 - 1 ? col + 1 : 0;
		n--;
	}
}

void
game()
{
	int i, col, row, cast, x, y;
	CARD card[5];

	/* ŏround_init()ŃEh1ɏ悤Around=0ɂĂ܂B */
	memset(&gi, 0, sizeof gi);
	for(;;) {
		/* EhB */
		round_init();

		for(;;) {
			/*---------- O ----------*/
			gi.phase = PHASE_PRE;
			/* ܂̂ƂȂɂȂłB */

			/*---------- RDItF[Y ----------*/
L10:
			gi.phase = PHASE_YAMA_SEL;
			/* RD̏Iʒu͑ȎIʒuƓ */
			while(gi.n_yama[gi.yama_sel] == 0) { /* ȎIŋɂȂꍇ͎̗ */
				gi.yama_sel++;
				while(gi.yama_sel >= 4) gi.yama_sel -= 4;
			}
			sound_play(1, S2);
			for(;;) {
				schedule();
				if(joy & TRG_LF) {
					for(;;) {
						gi.yama_sel--;
						while(gi.yama_sel < 0) gi.yama_sel += 4;
						if(gi.n_yama[gi.yama_sel] != 0) break;
					}
					sound_play(1, S4);
				}
				if(joy & TRG_RI) {
					for(;;) {
						gi.yama_sel++;
						while(gi.yama_sel >= 4) gi.yama_sel -= 4;
						if(gi.n_yama[gi.yama_sel] != 0) break;
					}
					sound_play(1, S4);
				}
				if(joy & TRG_A) break;
				field_disp();
			}

			/*---------- DItF[Y ----------*/
			gi.phase = PHASE_BA_SEL;
			gi.ba_sel = 2; /* D̏Iʒu͏ɂ܂Ȃ */
			sound_play(1, S2);
			for(;;) {
				schedule();
				if(joy & TRG_LF) {
					gi.ba_sel--;
					while(gi.ba_sel < 0) gi.ba_sel += 5;
					sound_play(1, S4);
				}
				if(joy & TRG_RI) {
					gi.ba_sel++;
					while(gi.ba_sel >= 5) gi.ba_sel -= 5;
					sound_play(1, S4);
				}
				if(joy & TRG_A) { /* IɏD̋󂫂ΑIm */
					if(gi.n_ba[gi.ba_sel] < 5) break;
				}
				if(joy & TRG_B) goto L10; /* RDIȂ */
				field_disp();
			}

			/*---------- ㏈ ----------*/
			gi.phase = PHASE_POST;

			/* J[hړB */
			gi.ba[gi.ba_sel][gi.n_ba[gi.ba_sel]++] = gi.yama[gi.yama_sel][0];
			memmove(&gi.yama[gi.yama_sel][0], &gi.yama[gi.yama_sel][1], sizeof(CARD) * --gi.n_yama[gi.yama_sel]);

			/* ̔B */
			for(row = 0; row < 5; row++) {
				if(!gi.cast_h[row]) {
					for(col = 0; col < 5; col++) {
						if(gi.n_ba[col] <= row) break; /* D̋ */
						card[col] = gi.ba[col][row];
					}
					if(col == 5) {
						sound_play(1, S1);
						gi.flash_h = row;
						gi.flash_v = -1;
						gi.flash_d = -1;
						for(i = 0; i < SEC(0.5); i++) {
							gi.flash = i >> 1 & 1;
							field_disp();
							schedule();
						}
						gi.flash = 0;
						cast = chk_cast(card);
						gi.cast_h[row] = cast;
						/* XRAZB */
						gi.score += cast_pts[cast];
						gi.total += cast_pts[cast];
					}
				}
			}

			/* ̔B */
			for(col = 0; col < 5; col++) {
				if(!gi.cast_v[col]) {
					if(gi.n_ba[col] == 5) {
						sound_play(1, S1);
						gi.flash_h = -1;
						gi.flash_v = col;
						gi.flash_d = -1;
						for(i = 0; i < SEC(0.5); i++) {
							gi.flash = i >> 1 & 1;
							field_disp();
							schedule();
						}
						gi.flash = 0;
						for(row = 0; row < 5; row++) {
							card[row] = gi.ba[col][row];
						}
						cast = chk_cast(card);
						gi.cast_v[col] = cast;
						/* XRAZB */
						gi.score += cast_pts[cast];
						gi.total += cast_pts[cast];
					}
				}
			}

			/* ΂ߖ̔B */
			if(!gi.cast_d[0]) {
				col = 0; /* E */
				for(row = 0; row < 5; row++) {
					if(gi.n_ba[col] <= row) break; /* D̋ */
					card[row] = gi.ba[col][row];
					col++;
				}
				if(row == 5) {
					sound_play(1, S1);
					gi.flash_h = -1;
					gi.flash_v = -1;
					gi.flash_d = 0;
					for(i = 0; i < SEC(0.5); i++) {
						gi.flash = i >> 1 & 1;
						field_disp();
						schedule();
					}
					gi.flash = 0;
					cast = chk_cast(card);
					gi.cast_d[0] = cast;
					/* XRAZB */
					gi.score += cast_pts[cast];
					gi.total += cast_pts[cast];
				}
			}
			if(!gi.cast_d[1]) {
				col = 5 - 1; /* E獶 */
				for(row = 0; row < 5; row++) {
					if(gi.n_ba[col] <= row) break; /* D̋ */
					card[row] = gi.ba[col][row];
					col--;
				}
				if(row == 5) {
					sound_play(1, S1);
					gi.flash_h = -1;
					gi.flash_v = -1;
					gi.flash_d = 1;
					for(i = 0; i < SEC(0.5); i++) {
						gi.flash = i >> 1 & 1;
						field_disp();
						schedule();
					}
					gi.flash = 0;
					cast = chk_cast(card);
					gi.cast_d[1] = cast;
					/* XRAZB */
					gi.score += cast_pts[cast];
					gi.total += cast_pts[cast];
				}
			}

			/* SĊm肵H */
			for(i = 0; i < 5; i++) {
				if(!gi.cast_h[i] || !gi.cast_v[i]) break;
			}
			if(i == 5 && gi.cast_d[0] && gi.cast_d[1]) break;
		}

		/* EFCgB */
		sound_play(1, S3);
		for(i = 0; i < SEC(1); i++) {
			field_disp();
			schedule();
		}

		/* ʕ\B */
		result_disp();

		/* z_ƌ݂̓_𑫂ĂKvȓ_ɒBĂȂ΁AQ[I[o[B */
		if(gi.stock + gi.total < gi.level) break;

		/* bkd`q */
		memset(vbuff, 3, sizeof vbuff);
		x = (DISP_X - 10 * 5) / 2;
		y = (DISP_Y - 10    ) / 2;
		sound_play(1, S3);
		render_string_framed(&render, x, y, "bkd`q", 0, 0x210);
		for(i = 0; i < SEC(3); i++) {
			schedule();
			if(joy & (TRG_A | TRG_B)) break;
		}
	}

	/* f`ldnudq */
	memset(vbuff, 3, sizeof vbuff);
	x = (DISP_X - 10 * 8) / 2;
	y = (DISP_Y - 10    ) / 2;
	sound_play(1, S3);
	render_string_framed(&render, x, y, "f`ldnudq", 0, 0x210);
	for(i = 0; i < SEC(3); i++) {
		schedule();
		if(joy & (TRG_A | TRG_B)) break;
	}

	/* nCXRAXVB */
	if(gi.score > hiscore) hiscore = gi.score;
}

/****************************************************************************
 *	card_disp
 ****************************************************************************/

void
card_disp(int x, int y, const CARD* card)
{
	render_object(&render, x, y, card->number * 16, card->suit * 24, 16, 24, DRW_NOMAL);
}

void
cast_disp(int x, int y, int cast, int rot)
{
	int sx, sy, w, h, param;

	switch(rot) {
	case 0: /* p */
	case 2: /* Ep */
		w = 7;
		h = 13;
		sx = 32 + w * cast;
		sy = 96;
		param = rot == 0 ? DRW_NOMAL : DRW_REVX | DRW_REVY;
		break;
	case 1: /* p */
		w = 13;
		h = 7;
		sx = 208;
		sy = 0 + h * cast;
		param = DRW_NOMAL;
		break;
	default:
		DIE();
		return; /* x} */
	}
	render_object(&render, x, y, sx, sy, w, h, param);
}

/****************************************************************************
 *	chk_cast
 ****************************************************************************/

static int
compare_number(const void* _a, const void* _b)
{
	int result;
	CARD* a = (CARD*)_a;
	CARD* b = (CARD*)_b;

	if(a->suit == 4 || b->suit == 4) { /* W[J[͕KŌ */
		result = a->suit - b->suit;
	} else if(a->number != b->number) {
		result = a->number - b->number;
	} else {
		result = a->suit - b->suit;
	}
	return result;
}

static void
sort_number(CARD card[5])
{
	qsort(card, 5, sizeof(CARD), compare_number);
}

static int
chk_1p(CARD card[5])
{
	int i;

	/* ׂ̃J[hƓio[΃yAłB */
	for(i = 0; i < 5 - 1; i++) {
		if(card[i + 0].number == card[i + 1].number) {
			return 1;
		}
	}

	return 0;
}

static int
chk_2p(CARD card[5])
{
	int i, n;

	/* ׂ̃J[hƓio[񂠂΃c[yAłB */
	n = 0;
	for(i = 0; i < 5 - 1; i++) {
		if(card[i + 0].number == card[i + 1].number) {
			n++;
			i++; /* ̃J[h͔΂ */
		}
	}
	if(n >= 2) return 1;

	return 0;
}

static int
chk_3c(CARD card[5])
{
	int i;

	/* io[OłX[J[hłB */
	for(i = 0; i < 5 - 2; i++) {
		if(card[i + 0].number == card[i + 1].number &&
		   card[i + 0].number == card[i + 2].number) {
			return 1;
		}
	}

	return 0;
}

static int
chk_fl(CARD card[5])
{
	/* ԓX[cȂtbVłB */
	if(card[0].suit == card[1].suit &&
	   card[0].suit == card[2].suit &&
	   card[0].suit == card[3].suit &&
	   card[0].suit == card[4].suit) {
		return 1;
	}

	return 0;
}

static int
chk_st(CARD card[5])
{
	/* ܂AԂȂXg[głB */
	if(card[0].number + 1 == card[1].number &&
	   card[0].number + 2 == card[2].number &&
	   card[0].number + 3 == card[3].number &&
	   card[0].number + 4 == card[4].number) {
		return 1;
	}

	/* A(0)-10(9)-J(10_-Q(11)-K(12) Ƃp^[łB
	 * (io[̂Ȃ A-2-3-4-5-6-7-8-9-10-J-Q-K-A )
	 *                                         ~~~~~~~~~~
	 */
	if(card[0].number ==  0 &&
	   card[1].number ==  9 &&
	   card[2].number == 10 &&
	   card[3].number == 11 &&
	   card[4].number == 12) {
		return 1;
	}

	return 0;
}

static int
chk_fh(CARD card[5])
{
	/* ```aãp^[B */
	if(card[0].number == card[1].number &&
	   card[0].number == card[2].number &&
	   card[3].number == card[4].number) {
		return 1;
	}

	/* ``aaãp^[B */
	if(card[0].number == card[1].number &&
	   card[2].number == card[3].number &&
	   card[2].number == card[4].number) {
		return 1;
	}

	return 0;
}

static int
chk_4c(CARD card[5])
{
	int i;

	/* io[lłtH[J[hłB */
	for(i = 0; i < 5 - 3; i++) {
		if(card[i + 0].number == card[i + 1].number &&
		   card[i + 0].number == card[i + 2].number &&
		   card[i + 0].number == card[i + 3].number) {
			return 1;
		}
	}

	return 0;
}

static int
chk_sf(CARD card[5])
{
	/* Xg[gŃtbVȂXg[gtbVłB */
	if(chk_st(card) && chk_fl(card)) {
		return 1;
	}

	return 0;
}

static int
chk_rsf(CARD card[5])
{
	/* uA-10-J-Q-KvŃXg[gtbVȂ烍CXg[gtbVłB */
	if(card[0].number == 0 && chk_sf(card)) {
		return 1;
	}

	return 0;
}

int
chk_cast(CARD card[5])
{
	CARD c1[5], c2[5];
	struct {
		int cast;
		int (*chk)(CARD card[5]);
	} cast[] = {
		//{ CAST_5C, chk_5c },
		{ CAST_RSF, chk_rsf },
		{ CAST_SF, chk_sf },
		{ CAST_4C, chk_4c },
		{ CAST_FH, chk_fh },
		{ CAST_ST, chk_st },
		{ CAST_FL, chk_fl },
		{ CAST_3C, chk_3c },
		{ CAST_2P, chk_2p },
		{ CAST_1P, chk_1p },
	};
	int i, j, k;

	/* J[hꎞobt@ɃRs[āAio[ɕёւ܂B */
	memcpy(c1, card, sizeof(CARD) * 5);
	sort_number(c1);

	/* W[J[Ȃ̏ꍇ... */
	if(c1[4].suit != 4) {
		for(i = 0; i < sizeof cast / sizeof *cast; i++) {
			if(cast[i].chk(c1)) return cast[i].cast;
		}

	/* W[J[̏ꍇ... */
	} else {
		/* t@CuJ[hʔBiW[J[dio[ƌȂ̂Łj */
		if(c1[0].number == c1[3].number) return CAST_5C;
		for(i = 0; i < sizeof cast / sizeof *cast; i++) {
			/* W[J[dȂJ[hɕύXȂA𔻒B */
			for(j = 0; j < 52/*W[J[ɂ͕ύXȂ̂53Ȃ!*/; j++) {
				c1[4].suit   = j / 13;
				c1[4].number = j % 13;
				for(k = 0; k < 4; k++) {
					if(c1[k].suit   == c1[4].suit &&
					   c1[k].number == c1[4].number) break;
				}
				if(k < 4) continue;
				memcpy(c2, c1, sizeof(CARD) * 5);
				sort_number(c2);
				if(cast[i].chk(c2)) return cast[i].cast;
			}
		}
	}

	return CAST_HC;
}

/****************************************************************************
 *	field_disp
 ****************************************************************************/

static void info_disp();

void
field_disp()
{
	int x, y, col, row;
	const CARD* card;

	memset(vbuff, 1, sizeof vbuff);

	/*---------- \ ----------*/
	/*  */
	x = 1;
	y = 112;
	for(row = 0; row < 5; row++) {
		cast_disp(x, y, gi.cast_h[row], 0);
		y -= 16;
	}
	/* 㑤 */
	x = 10;
	y = 32;
	for(col = 0; col < 5; col++) {
		cast_disp(x, y, gi.cast_v[col], 1);
		x += 14;
	}
	/* ΂ */
	x = 81;
	y = 32;
	cast_disp(x, y, gi.cast_d[0], 2);
	x = 1;
	y = 32;
	cast_disp(x, y, gi.cast_d[1], 0);

	/*---------- J[h\ ----------*/
	/* D̘g */
	for(col = 0; col < 5; col++) {
		for(row = 5 - 1; row >= gi.n_ba[col]; row--) { /* g͉قǎO(ɒu) */
			x = 9 + col * 14;
			y = 104 - row * 16;
			card_disp(x, y, &guide);
		}
	}
	/* D */
	for(col = 0; col < 5; col++) {
		for(row = 0; row < gi.n_ba[col]; row++) { /* قǎOȂ̂ŉ */
			x = 9 + col * 14;
			y = 104 - row * 16;
			card = &gi.ba[col][row];
			if(gi.flash) {
				if(gi.flash_h == row ||
				   gi.flash_v == col ||
				   (gi.flash_d == 0 && col - row == 0    ) ||
				   (gi.flash_d == 1 && col + row == 5 - 1)) {
					card = &flash_b;
				}
			}
			card_disp(x, y, card);
		}
	}
	/* RD */
	for(col = 0; col < 4; col++) {
		for(row = gi.n_yama[col] - 1; row >= 0; row--) { /* قǎOȂ̂ŏォ牺 */
			x = 16 + col * 14;
			y = 7 - row * 3;
			if(row == 0) { /* ΂ÕJ[h... */
				switch(gi.phase) {
				case PHASE_PRE: /* IJ[hʏ\ */
					card_disp(x, y, &gi.yama[col][row]);
					break;
				case PHASE_YAMA_SEL: /* IJ[hĕ\ */
					if(col == gi.yama_sel) y += 3;
					card_disp(x, y, &gi.yama[col][row]);
					break;
				case PHASE_BA_SEL: /* IJ[hȊOʏ\BIJ[h͌ŕ\ */
					if(col != gi.yama_sel) card_disp(x, y, &gi.yama[col][row]);
					break;
				case PHASE_POST: /* IJ[hȊOʏ\BIJ[h͕\Ȃ */
					if(col != gi.yama_sel) card_disp(x, y, &gi.yama[col][row]);
					break;
				default:
					DIE();
				}
			} else { /* ΂OȊÕJ[h͕ĕ\ */
				card_disp(x, y, &reversed);
			}
		}
	}
	if(gi.phase == PHASE_BA_SEL) { /* DItF[Y̑IJ[h\ */
		col = gi.yama_sel;
		row = 0;
		x = 9 + gi.ba_sel * 14;
		y = 24;
		card_disp(x, y, &gi.yama[col][row]);
	}

	/* \B */
	if(gi.info_cnt < SEC(1.5)) { /* EhJn̋\ */
		gi.info_pos += 16;
		gi.info_cnt++;
		if(joy & TRG_MASK) gi.info_cnt = SEC(1.5); /* LZ */
	} else {
		if(joy & PAD_SELECT) {
			gi.info_pos += 16;
		} else {
			gi.info_pos -= 16;
		}
	}
	if(gi.info_pos < 0) gi.info_pos = 0;
	if(gi.info_pos > DISP_X) gi.info_pos = DISP_X;
	info_disp();
}

static void
info_disp()
{
	int x1, x2, y, n;

	if(!gi.info_pos) return;

	if((x1 = gi.info_pos - DISP_X) > 0) x1 = 0;
	if((x2 = DISP_X - gi.info_pos) < 0) x2 = 0;

	y = 47;
	render_printf_framed(&render, x1 + 4, y, 0, 0x123, "Eh  %6d", gi.round); y += 11;
	render_printf_framed(&render, x2 + 4, y, 0, 0x123, "v_  %6d", gi.score); y += 16;
	render_printf_framed(&render, x1 + 4, y, 0, 0x123, "Kvȓ_%6d", gi.level); y += 11;
	render_printf_framed(&render, x2 + 4, y, 0, 0x123, "z_%6d", gi.stock); y += 11;
	render_printf_framed(&render, x1 + 4, y, 0, 0x123, "݂̓_%6d", gi.total); y += 11;
	if((n = gi.level - gi.stock - gi.total) < 0) n = 0;
	render_printf_framed(&render, x2 + 4, y, 0, 0x123, "cKv_%6d", n);        y += 11;
}

/****************************************************************************
 *	result_disp
 ****************************************************************************/

void
result_disp()
{
	unsigned char cnt[NUM_CAST];
	int i, cast, x, y;

	memset(vbuff, 3, sizeof vbuff);

	/* e̐𐔂܂B */
	memset(cnt, 0, sizeof cnt);
	for(i = 0; i < 5; i++) {
		cast = gi.cast_h[i];
		cnt[cast]++;
		cast = gi.cast_v[i];
		cnt[cast]++;
	}
	for(i = 0; i < 2; i++) {
		cast = gi.cast_d[i];
		cnt[cast]++;
	}

	/* 01234567890123 */
	/*  qdrtks  */
	/* 1P ~99 =99999 */
	/* 2P ~99 =99999 */
	/* 3C ~99 =99999 */
	/* FL ~99 =99999 */
	/* ST ~99 =99999 */
	/* FH ~99 =99999 */
	/* 4C ~99 =99999 */
	/* SF ~99 =99999 */
	/* RSF~99 =99999 */
	/* 5C ~99 =99999 */
	/* [TOTAL] =99999 */
	x = (DISP_X - 5 * 14) / 2;
	y = 0;
	sound_play(1, S4);
	render_string_framed(&render, x, y, " qdrtks ", 0, 0x013);
	y += 13;
	for(i = 0; i < SEC(0.1); i++) schedule();
	for(cast = CAST_1P; cast <= CAST_5C; cast++) {
		sound_play(1, S4);
		render_printf_framed(&render, x, y, 0, 0x013, "%s~%2d =%5d", cast_str[cast], cnt[cast], cast_pts[cast] * cnt[cast]);
		y += 10;
		for(i = 0; i < SEC(0.1); i++) schedule();
	}
	y += 3;
	sound_play(1, S4);
	render_printf_framed(&render, x, y, 0, 0x013, "[TOTAL] =%5d", gi.total);
	for(i = 0; i < SEC(3); i++) {
		schedule();
		if(joy & (TRG_A | TRG_B)) break;
	}
}

/****************************************************************************
 *	doc_disp
 ****************************************************************************/

void
doc_disp(int cast)
{
	int i, x, y;

	y = 1;

	/* }[N */
	x = 1;
	cast_disp(x, y + 2, cast, 1);

	/*  */
	x += 13;
	render_string_framed(&render, x, y, cast_name[cast], 0, 0x131);
	y += 11;

	/* _ */
	x = DISP_X - (5 * 6 + 3);
	render_printf_framed(&render, x, y, 0, 0x120, "%4d_", cast_pts[cast]);
	y += 24;

	/* J[h */
	x = 9;
	for(i = 0; i < 5; i++) {
		card_disp(x, y, &cast_smpl[cast][i]);
		x += 14;
	}
	y += 36;

	/*  */
	x = 4;
	render_string_framed(&render, x, y, cast_doc[cast], 0, 0x120);
}
